#! /usr/bin/env python

# ========= accounts.py ===========================================
# Cration automatique de comptes utilisateurs Unix & Samba sur un
# serveur Linux destin  la gestion d'un intranet scolaire
# Ce script a t test seulement sous Linux SuSE 6.3 -> 8.0
#
# Explications : voir http://www.ulg.ac.be/cifen/inforef/swi
# (C) Grard Swinnen, Lige (Belgique).  - Licence : GPL
# =================================================================

import string                      # fonctions de traitement des chanes
import os                          # appels au systme d'exploitation
import sys                         # fonctions systme gnralistes
from crypt import crypt            # routines de cryptage
from whrandom import randint       # gnrateur de nombres alatoires
from os.path import exists         # test d'existence d'un chemin
import pwd                         # accs aux infos de /etc/passwd
import grp                         # accs aux infos de /etc/group

version = '04/09/2002'
profGrp = "staff"
lettres = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
lettresAcc = lettres + "-" + string.digits

def deleteLine(keyword,fichier):
    # du fichier spcifi, supprimer les lignes qui commencent par
    # la chane <keyword> suivie d'un ":"
    if len(keyword) == 0:
        return
    # 1) renommer le fichier source, puis l'ouvrir en lecture :
    os.rename(fichier,'source')
    fis = open('source', 'r')
    # 2) crer un nouveau fichier et l'ouvrir en criture :
    fid = open(fichier, 'w')
    # 3) transfrer de l'un  l'autre, en filtrant :
    while 1:
        li = fis.readline()            # lire les lignes une par une
        if len(li) == 0:               # dtecter la fin de fichier
            break
        ll = string.split(li,':')      # sparer les sous-chanes
        if ll[0] == keyword:           # sauter les lignes qui commencent
            pass                       # par une sous-chane identique  keyword
        else:
            fid.write(li)              # transcrire les autres
    fis.close()
    fid.close()
    os.system('chmod 600 '+ fichier)   # attributs de scurit
    os.remove('source')                # effacer l'ancienne version


def sambaPass(user,passwd):
    # Pour inscrire le mot de passe dans la base de scurit de Samba, on doit
    # utiliser la commande <smbpasswd -s> , laquelle attend 2 entres clavier
    # (le mot de passe, 2 fois pour confirmation).
    # La solution pour passer ces entres est d'ouvrir un 'pipe'  l'aide de
    # la fonction os.popen("commande"). Cette fonction retourne un
    # "objet fichier" reli au pipe, auquel on peut appliquer les mthodes
    # applicables aux fichiers, telle write() :
    of = os.popen("smbpasswd -a -s %s" % (user), 'w')
    of.write(passwd +'\n' +passwd +'\n')
    if of.close():
        print "** Pas moyen d'ajouter cet utilisateur dans /etc/private/smbpasswd."
        os.system("userdel %s" % (user))
        print "   => le compte utilisateur n'a pas t cr."

def deleteDirectory(dir):
    "Effacement du rpertoire dir (aprs confirmation si non vide) :"
    if exists(dir):
        try:
            os.rmdir(dir)
        except:
            print "*********************** !! ATTENTION !! ************************"
            print "Le rpertoire %s contient encore les lments suivants :" % (dir)
            print os.listdir(dir)
            dd = raw_input("Etes-vous certain de vouloir l'effacer (o/n) ? ")
            if string.lower(dd[0]) == 'o':
                os.system('rm -R ' + dir)               # -R pour rcursivit
    else:
        print "Le rpertoire %s n'existe pas !" % (dir)

def createSmbpasswd():
    "Cration de la base de scurit Samba (fichier /etc/private/smbpasswd)"
    if not exists('/etc/private'):
        os.mkdir('/etc/private', 0500)	    
    while 1:
        tt = os.system('cat /etc/passwd | mksmbpasswd.sh > /etc/private/smbpasswd')
        if tt == 0:
            break
        else:
            # Dans certaines distributions Linux, le script mksmbpasswd
            # n'est pas accessible par dfaut. L'installer si ncessaire :
            print "** Script mksmbpasswd.sh inactif - Essai d'installation : "
            # recherche dans plusieurs chemins possibles :
	    for chem in ['/usr/lib/samba/scripts','/usr/share/samba/script']:
		tt = os.system("cp %s/mksmbpasswd.sh /usr/local/bin" % chem)
		if tt == 0:
		    break	    
            if tt == 0:
                tt = os.system('chmod 500 /usr/local/bin/mksmbpasswd.sh')
                if tt == 0:
                    print "OK - Script install et fonctionnel."
                else:
                    print "** Script install mais pas excutable ???"
                    sys.exit()
            else:
                print "** Script introuvable - Veuillez l'installer manuellement."
                sys.exit()

def savepasswords():
    "Sauvegarde des fichiers de mots de passe prexistants (Unix & Samba)"
    pwFiles =["/etc/private/smbpasswd","/etc/passwd"]
    for pFile in pwFiles:
        n =0
        while 1:
            if not exists(pFile + "Bak" + str(n)):
               bkFile = pFile + "Bak" + str(n)
               break
            else:
               n = n+1
        os.system("cp " + pFile + " " + bkFile)
        print "Note : le fichier %s prcdent est" % (pFile)
        print "sauvegard sous le nom %s." % (bkFile)


def existsUser(u):
   "Vrifier si l'utilisateur u est bien rpertori dans /etc/passwd"
   try:
      t = pwd.getpwnam(u)     # retourne un tuple avec paramtres user
   except:
      return 0
   else:
      return 1


def existsGroup(g):
   "Vrifier si le groupe g est bien rpertori dans /etc/group"
   try:
      t = grp.getgrnam(g)     # retourne un tuple avec paramtres du groupe
   except:
      return 0
   else:
      return 1


def notUnixWord(mot):
    "<mot> est-il un label UNIX correct ? retourne 1 si non"
    if len(mot) <1 or len(mot) >8:
       return 1
    # le premier caractre doit tre alphabtique :
    if mot[0] not in lettres:
       return 1
    # les autres caractres doivent tre alphanumriques :
    for c in mot:
       if not (c in lettres or c in string.digits):
          return 1
    return 0


def createGroup(group):
    # Cration du groupe Unix + cration des rpertoires associs
    global profGrp, boss, quotas
    if existsGroup(group):
       print "Le groupe-classe %s existe dj." % (group)
    else:
       print "*** Cration du groupe-classe %s : ***" % (group)
       os.system('groupadd '+ group)
       
    # Cration des rpertoires <privs> associs au groupe :
    try:
       os.mkdir('/home/' + group, 0755)
       os.mkdir('/home/' + group + '/bureau', 0755)
       os.mkdir('/home/' + group + '/apps', 0755)
       os.mkdir('/home/' + group + '/start', 0755)
       os.mkdir('/home/' + group + '/smenu', 0755)
    except OSError,Errno:             # <File exists> error
       if Errno[0] == 17:
          print"Le rpertoire home existe dj pour le groupe %s." % (group)
       else:
          print "Erreur systme N", Errno
          
    # Papier peint Windows par dfaut :
    if wallpap != "":
	   os.system("cp %s /home/%s/background" % (wallpap, group))
	
    # Cration des rpertoires <publics> associs au groupe :
    try:
       os.mkdir('/home/siteweb/' + group, 0755)
    except OSError,Errno:             # <File exists> error
       if Errno[0] == 17:
          print"Le rp. home/siteweb existe dj pour le groupe %s." % (group)
       else:
          print "Erreur systme N", Errno

    # Le propritaire des rpertoires crs est un membre du groupe.
    # Par dfaut, son nom est celui du groupe (converti en minuscules):
    boss = string.lower(group)
    if not existsUser(boss):
        print "Il est cr automatiquement un utilisateur propritaire"
        print "pour l'environnement de travail de cette classe."
        print 'Son nom est : "%s".' % (boss)
        bossPass = 'abcde'              # mot de passe
        b = raw_input("Mot de passe du propritaire [abcde] : ")
        if len(b) >0:
            bossPass = b
        # Pour comprendre ce qui suit, veuillez consulter la documentation
        # concernant le cryptage des mots de passe UNIX :
        salt = chr(randint(1,26)+64) + chr(randint(1,26)+96)
        crPass = crypt(bossPass,salt)
        # Rpertoire personnel du Boss = rp. rserv au groupe :
        os.system("useradd -g %s -p %s -d /home/%s -c propritaire %s"
                   % (group, crPass, group, boss))
        # Enreg. du mot de passe galement crypt  la mode Samba
        # (l'utilisateur concern doit exister au pralable !) :
        sambaPass(boss, bossPass)

    # Appropriations (paramtre -R pour inclure les sous-rpertoires):
    if exists("/home/" + group):
       os.system("chgrp -R %s /home/%s" % (group, group))
       os.system("chown -R %s /home/%s" % (boss, group))
    else:
       print "??? Rpertoire /home/%s inexistant ???" % (group)
       sys.exit()
    if exists("/home/siteweb/" + group):
       os.system("chgrp -R %s /home/siteweb/%s" % (group, group))
       os.system("chown -R %s /home/siteweb/%s" % (boss, group))
    else:
       print "??? Rpertoire /home/siteweb/%s inexistant ???" % (group)
       sys.exit()
       
    # Un groupe de profs aura tous les droits sur les rpertoires
    # "privs" des lves :
    print "Un groupe de professeurs aura droit de regard sur les"
    print "rpertoires personnels des lves de cette classe."
    print "Quel nom choisissez-vous pour ce groupe de profs ?"
    print "(Le groupe sera cr s'il n'existe pas dj) [%s] : " % (profGrp),
    b = raw_input()
    if len(b) >0:
        profGrp = b
    os.system('groupadd '+ profGrp)


def setQuotas(group):
    # Attribution de quotas au "chef" de groupe :
    global quotas
    if not existsGroup(group):
        return
    if quotas =='o':
       while 1:
          proto = raw_input("""Veuillez entrer le nom de l'utilisateur choisi comme
prototype pour l'tablissement des quotas disque
attribus  ces lves : """)
          if existsUser(proto):
             # attribution de ces quotas au "chef" du groupe :
             os.system("edquota -p %s -u %s" % (proto, string.lower(group)))
             break
          else:
             print "******* Cet utilisateur n'existe pas !!!"


def scanUsers(step):
    # traitement des donnes utilisateur pour crer les comptes personnels :
    global linUsers
    fichier = open(usersFile,'r')
    count = 0
    while 1:
        ligne = fichier.readline()
        if not ligne:                           # dtection de la fin de fichier
            break                               # (la ligne lue est vide)
        # nom de l'utilisateur, groupe, mot de passe, commentaire :
        count = count +1
        ll = string.split(ligne)
        if len(ll) <3:                          # ligne incomplte (moins de 3 champs)
            print "*** Ligne %s incomplte dans le fichier source. ***" % (count)
            continue            

        if len(ll[0]) <9 and len(ll[1]) <9 and len(ll[2]) <9:
            # analyse de la ligne suivant nouvelle convention :
            user = ll[0]
            group = ll[1]
            passw = ll[2]
            comment = string.join(ll[3:])
        else:
            # analyse de la ligne suivant ancienne convention :
            user = string.strip(ligne[:8])
            group = string.strip(ligne[8:16])    # limination des espaces
            passw = string.strip(ligne[16:24])   # en dbut et fin de chane
            comment = string.strip(ligne[24:])
            
        # Vrifications diverses. D'abord s'assurer que les identifiants sont OK : 
        if notUnixWord(user) or notUnixWord(group):
            print
            print "User = %s , Group = %s, Passwd = %s ???" % (user,group,passw)
            print "*** Ligne %s incorrecte dans le fichier source. Job annul. ***" % (count)
            sys.exit()

        # Il faut s'assurer que le commentaire associ  chaque utilisateur ne
        # contienne que des caractres "autoriss" (sinon -> erreur systme).
        if len(comment) ==0:
            comment ='---'
        else:
            # Construire d'abord la liste des caractres "illgaux" prsents :
            lc =[]                      
            for cx in comment:
                if cx not in lettresAcc:
                    lc.append(cx)
            # remplacer les caractres "illgaux" trouvs par des '_' :        
            for cx in lc:               
                comment = string.replace(comment,cx,'_')
            
        # Mise  jour de la liste des groupes dj rencontrs :
        if not(group in grpList):
            grpList.append(group)       # on ajoute le groupe  la liste
            if step == 1:
               # Cration du groupe et de ses rpertoires associs :
               print ""
               createGroup(group)
               setQuotas(group)

        if step == 2:
            # Cration des utilisateurs et de leurs rpertoires personnels
            if not existsGroup(group):
                continue        # passer  l'enreg. suivant
            # le rp. attribu  chaque lve est un sous-rp. de celui du groupe :
            homeDir = '/home/%s/%s' % (group, user)
            if existsUser(user):
               print "L'utilisateur %s existe dj." % (user)
            else:
               # Voir documentation sur le cryptage des mots de passe :
               salt = chr(randint(1,26)+64) + chr(randint(1,26)+96)
               crPass = crypt(passw,salt)
               # Ajout d'un compte utilisateur :
               os.system("useradd -g %s -p %s -d %s -c %s %s"
                          % (group, crPass, homeDir, comment, user))
               # encodage des mots de passe galement  la sauce Samba :
               sambaPass(user, passw)

            # Cration des sous-rpertoires personnels privs pour chacun :
            if not exists(homeDir):
               os.mkdir(homeDir)
               os.mkdir(homeDir + '/bureau', 0755)
               os.mkdir(homeDir + '/apps', 0755)
               os.mkdir(homeDir + '/start', 0755)
               os.mkdir(homeDir + '/smenu', 0755)

            # Installation d'un 'papier peint' par dfaut :
            if not exists(homeDir + "/background"):
               if exists("/home/%s/background" % (group)):
                  os.system("cp /home/%s/background %s" % (group, homeDir))

            # copie d'un "squelette" d'environnement Linux s'il y a lieu:
            if linUsers =='o':
               os.system("cp -au /etc/skel/.[^.]* %s" % (homeDir))
            # Note : la syntaxe utilise ici fait appel  l'expression
            # rgulire [^.] pour dsigner "tout autre caractre que le point"
            # (on copie ainsi tout ce qui commence par un point et un seul,
            #  en vitant de copier aussi le rpertoire parent)

            # (R)Appropriations :
            os.system("chgrp -R %s /home/%s/%s" % (profGrp, group, user))
            os.system("chown -R %s /home/%s/%s" % (user, group, user))
            os.system("chmod 2770 /home/%s/%s" % (group, user))
            # Droits d'accs : le 2 en premier lieu positionne le bit GID,
            # De ce fait les fichiers mmoriss dans ce rpertoire seront
            # attribus au mme groupe que le rpertoire lui-mme (cd profGrp)

            # Rpertoire personnel accessible aux autres en lecture :
            if not exists("/home/siteweb/%s/%s" % (group, user)):
               os.mkdir("/home/siteweb/%s/%s" % (group, user))

            # (R)Appropriations :
            os.system("chgrp -R %s /home/siteweb/%s/%s" % (profGrp, group, user))
            os.system("chown -R %s /home/siteweb/%s/%s" % (user, group, user))
            os.system("chmod 2775 /home/siteweb/%s/%s" % (group, user))

        elif step == 4:
            # tablissement des quotas (semblables  ceux du "chef"
            # de groupe, lequel a reu ceux du prototype) :
            print "Etablissement des quotas disque pour %s" % (user)
            proto = string.lower(group)
            os.system("edquota -p %s -u %s" % (proto, user))

        elif step == 5:
            # Suppression des utilisateurs :
            if existsUser(user):
               os.system("smbpasswd -d %s" % (user))
               # la ligne ci-dessus ne fait que dsactiver les comptes Samba
               # la fonction ci-dessous efface les lignes correspondantes :
               if exists('/etc/private/smbpasswd'):
                   deleteLine(user, '/etc/private/smbpasswd')
               os.system('userdel ' + user)
               # Suppression des rpertoires de l'utilisateur :
               os.system("rm -R /home/%s/%s" % (group, user))   # -R pour rcursivit
               os.system("rm -R /home/siteweb/%s/%s" % (group, user))
            else:
               print "L'utilisateur %s n'existe pas !!!" % (user)

    fichier.close()


###### Main program #######################

print """
===========================================================
       Cration automatique de comptes utilisateurs.
    (C) G.Swinnen - Version du %s - Licence GPL
===========================================================

Il faut avoir prpar  l'avance un fichier texte contenant
une ligne pour chaque lve, avec les champs suivants
spars par des espaces : Identifiant de l'lve (max 8c)
Classe(max 8c) Mot de passe(max 8c) Commentaire(max 40c).
Ce fichier peut tre cr aisment  partir de la base de
donnes PROECO, au moyen du logiciel NETUSERS de G.Swinnen
(logiciel  utiliser sous Window$).

Pour que les mots de passe soient transcrits aussi dans la
base de scurit de Samba (fichier /etc/private/smbpasswd),
il faut que le serveur Samba soit actif, et notamment que
/etc/smb.conf contienne l'indication correcte du chemin
menant  ce fichier (lequel doit tre bien protg).

(Dtails sur http://www.ulg.ac.be/cifen/inforef/swi)

                   ... / ...""" % (version)
k = raw_input()
print """Si vous le souhaitez, des quotas disque pourront tre
automatiquement tablis pour chaque lve, mais pour cela
il faut que le systme de quotas soit activ, et il faut
avoir dfini  l'avance les quotas d'un ou de plusieurs
utilisateurs qui serviront de "prototypes".
(Vous pouvez tablir ou modifier ces quotas  tout moment :
 Il vous suffira pour cela de relancer le prsent script).

Afin que les rpertoires personnels des lves soient
accessibles  certains professeurs, il faut que les noms
de ceux-ci soient incorpors dans un ou plusieurs groupe(s)
spcialement cr(s)  cet effet. Vous pouvez crer un groupe
diffrent pour chaque classe si ncessaire.
(Un mme professeur peut faire partie de plusieurs groupes).
"""

usersFile = raw_input("Veuillez entrer le nom du fichier dcrivant les lves : ")
if not exists(usersFile):
   print 'Ce fichier est introuvable ! Recommencez.'
   sys.exit()

choix = raw_input("""
Veuillez  prsent entrer :
'c' pour crer les comptes utilisateur pour ces lves,
    ou bien pour tablir/modifier leurs quotas disque
's' pour supprimer les comptes de ces lves
'q' pour quitter le prsent script sans rien faire : """)

grpList =[]
scanUsers(0)        # test du fichier source
grpList =[]

if choix =='c':
    while 1:
       quotas = raw_input("""
Dsirez-vous tablir ou modifier des quotas d'espace disque
  pour ces lves (o/n) ? : """)
       quotas = string.lower(quotas[0])
       if quotas =='o' or quotas =='n':
           break

    while 1:
       linUsers = raw_input("""
Dsirez-vous installer un environnement Linux pour chaque utilisateur ?
  (Rpondez NON  cette question si vos postes de travail fonctionnent
   sous Window$ exclusivement)     (o/n) ? : """)
       linUsers = string.lower(linUsers[0])
       if linUsers =='o' or linUsers =='n':
           break

    while 1:
       wallpap = raw_input("""
Vous pouvez indiquer ici le chemin d'un "papier peint" Windows
qui sera install comme fond d'cran par dfaut dans le rpertoire
personnel de chacun, sous le nom de fichier <background>.
(Chaque leve pourra ensuite remplacer ce fichier  son gr)
Attention : le fichier doit obligatoirement tre de type .BMP
Veuillez indiquer le chemin d'un tel fichier, ou <Enter> :
""")
       if wallpap == "" or exists(wallpap):
           print
           break

    # Cration du rpertoire rserv aux pages Web perso. des lves :
    if not exists('/home/siteweb'):
        os.mkdir('/home/siteweb',0755)
    # Cration de la base de scurit de Samba si elle n'existe pas dj :
    if not exists('/etc/private/smbpasswd'):
        print "Base de donnes smbpasswd inexistante - Essai de cration :"
        createSmbpasswd()		    
        os.chmod('/etc/private/smbpasswd', 0600)
        print "OK - Base de donnes smbpasswd  prsent installe."
    # Suppression de la ligne correspondant aux comptes NIS (ventuelle) :
    deleteLine('+', '/etc/private/smbpasswd')
    scanUsers(1)        # cration des groupes
    print
    scanUsers(2)        # cration des utilisateurs
    if quotas =='o':
        print
        scanUsers(4)    # tablissement des quota

elif choix =='s':
    print '''
***** !! ATTENTION !! **********************************************
*  Toutes les donnes contenues dans les rpertoires personnels    *
* de ces lves seront effaces sans possibilit de rcupration ! *
********************************************** !! ATTENTION !! *****
'''
    confirm = raw_input("Confirmez-vous l'effacement (o/n) ?")
    if confirm =='o':
        savepasswords()    # sauvegarde pralable des fichiers passwd
        scanUsers(5)       # suppression des utilisateurs (les groupes restent).
        print "Les groupes ci-dessous doivent-ils aussi tre effacs :"
        for g in grpList:
            print g,
        print
        delgr = raw_input("Effacer ces groupes (o/n) ? ")
        if delgr =='o':
            for group in grpList:
                deleteDirectory('/home/' + group)
                deleteDirectory('/home/siteweb/' + group)
                if exists('/home/' + group) or exists('/home/siteweb/' + group):
                    # Ne pas supprimer le groupe si l'un ou l'autre des
                    # rpertoires correspondants n'a pas t effac
                    print "Le groupe %s n'a pas t supprim." % (group)
                else:
                    os.system('smbpasswd -d ' + string.lower(group))
                    if exists('/etc/private/smbpasswd'):
                        deleteLine(string.lower(group), '/etc/private/smbpasswd')
                    os.system('userdel ' + string.lower(group))
                    os.system('groupdel ' + group)

print '''
Job termin.
'''
